import os.path
CONFIGDIR = os.path.normcase(os.path.abspath(__file__)).rsplit('/', 1)[0]

modules = ("GuiOverview","GuiProdmon","GuiExample")

envsetup = """
  source /data/sw/cmsset_default.sh
  source /data/sw/slc4_ia32_gcc345/cms/webtools/1.3.0/etc/profile.d/dependencies-setup.sh
"""

server.port        = 9000
server.serverDir   = '/data/overview/server'
server.baseUrl     = '/overview'
server.title       = 'CMS computing'
server.serviceName = 'Computing overview'

server.service('Computing overview', 'http://cmsmac01.cern.ch/overview')

server.source('phedex',  'DataTransfer',  CONFIGDIR + '/dbparam.py')
server.source('caf',     'CAFLemonPlot')
#server.source('LHC',   'LHC')
server.source('TPG',    'TPG')
server.source('Prodmon', 'Prodmon')

server.workspace('PhEDEx',  'DataTransfer')
server.workspace('CAF',     'CAF')
#server.workspace('LHC', 'LHC')
server.workspace('TPG','TPG')
server.workspace('Prodmon', 'Prodmon')
