#ifndef VISMONITORING_DQMSERVER_VISDQMRENDERDAEMON_H
# define VISMONITORING_DQMSERVER_VISDQMRENDERDAEMON_H

# include "VisMonitoring/DQMServer/interface/VisDQMImageServer.h"
# include "classlib/iobase/Filename.h"
# include "classlib/utils/Signal.h"

class VisDQMRenderDaemon
{
public:
  static const int FATAL_OPTS = (lat::Signal::FATAL_DEFAULT
				 & ~(lat::Signal::FATAL_ON_INT
				     | lat::Signal::FATAL_ON_QUIT
				     | lat::Signal::FATAL_DUMP_CORE));

  VisDQMRenderDaemon(int argc, char **argv);
  virtual ~VisDQMRenderDaemon(void);

  int			execute(void);

protected:
  virtual void		runServer(const VisDQMImageServer::ServerInfo &info) = 0;
  virtual bool		parseOption(int &i, int argc, char **argv);
  virtual std::string	showOptions(void);
  std::ostream &	logme(void);

private:
  static char		onAssertFail(const char *message);

private:
  char			**argv_;
  int			argc_;
};

#endif // VISMONITORING_DQMSERVER_VISDQMRENDERDAEMON_H
