GUI.Plugin.CAFSystemSummary = new function()
{
  var _gcanvas = document.getElementById('canvas-area');

  this.attach = function(gui)
  {
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    var content = ""
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>Availability</h3>"
      + "<img id='i-caf-avail' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/avail' /><br />"
      + "<img id='i-caf-free' style='margin:-0.75em 0 1em' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/disk-free' /><br />"
      + "<img id='i-caf-freepct' style='margin:-0.75em 0 1em' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/disk-freepct' />"
      + "</div>"
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>System utilisation</h3>"
      + "<img id='i-caf-use-cpu' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/sysuse-cpu' /><br />"
      + "<img id='i-caf-use-net' style='margin:-.75em 0 1em' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/sysuse-net' /><br />"
      + "</div>";

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (_gcanvas.style.display != '')
      _gcanvas.style.display = '';
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.update = function(data)
  {
    for (var i = 0, e = document.images.length; i < e; ++i)
    {
      var img = document.images[i];
      if (img.src.indexOf("/plotfairy/") >= 0)
      {
	var baseurl = img.src.replace(/\?.*/, "");
	GUI.ImgLoader.load("img" + i, img, baseurl + "?session="
			   + SESSION_ID + ";version=" + data.version);
      }
    }
  }

  return this;
}();

GUI.Plugin.CAFJobSummary = new function()
{
  var _gcanvas = document.getElementById('canvas-area');

  this.attach = function(gui)
  {
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    var content = ""
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>Jobs running at CAF</h3><img id='i-jobs-all' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-all' />"
      + "<h3>All CMSPHYS jobs</h3><img id='i-jobs-phys' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-cmsphys' />"
      + "</div>"
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h3>All CMSCOMM jobs</h3><img id='i-jobs-comm' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-cmscomm' />"
      + "<h3>All CMSALCA jobs</h3><img id='i-jobs-alca' style='margin:1em 0' src='"
      + ROOTPATH + "/plotfairy/cerncaf-lemon/job-queue-cmsalca' />"
      + "</div>";

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (_gcanvas.style.display != '')
      _gcanvas.style.display = '';
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.update = function(data)
  {
    for (var i = 0, e = document.images.length; i < e; ++i)
    {
      var img = document.images[i];
      if (img.src.indexOf("/plotfairy/") >= 0)
      {
	var baseurl = img.src.replace(/\?.*/, "");
	GUI.ImgLoader.load("img" + i, img, baseurl + "?session="
			   + SESSION_ID + ";version=" + data.version);
      }
    }
  }

  return this;
}();
