GUI.Plugin.ProdmonSummary = new function()
{
  var _gcanvas = document.getElementById('canvas-area');
  var _gui = null;
  var _self = this;

  this._divSite = null;
  this._divStats = null;
  this._divWF = null;
  this._divAlert = null;
  
  this._imageSite = null;
  this._imageWF = null;
  this._legendSite = null;
  this._legendWF = null;
  
  this._mapSite = null;
  this._mapWF = null;

  this.attach = function(gui)
  {
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    _gui = gui;
    var content = ""
      + "<div class='item' style='float:left;clear:both;padding:.5em'>"
      + "<h2>Alerts</h2>"
      + "<div id='prodmon-alert-table' style='float:left'></div>"
      + "</div>"
      + "<div class='item' style='float:left;clear:both;padding:.5em'>"
      + "<h2>Statistics</h2>"
      + "<div id='prodmon-stats-table' style='float:left'></div>"
      + "</div>"   
      + "<div class='item' style='float:left;clear:both;padding:.5em'>"
      + "<h2>Workflows:</h2>"
      + "<div id='prodmon-workflow-table' style='float:left'></div>"
      + "<img id='prodmon-workflow-image' style='float:right' usemap='#prodmon-workflow-map'>"
//      + "<img id='prodmon-workflow-legend' style='float:right;clear:right'>"
      + "<map name='prodmon-workflow-map' id='prodmon-workflow-map'></map>"
      + "</div>"
      + "<div class='item' style='float:left;padding:.5em'>"
      + "<h2>Sites:</h2>"
      + "<div id='prodmon-site-table' style='float:left'></div>"
      + "<img id='prodmon-site-image' style='float:right' usemap='#prodmon-site-map'>"
//      + "<img id='prodmon-site-legend' style='float:right;clear:right'>"
      + "<map name='prodmon-site-map' id='prodmon-site-map'></map>"
      + "</div>";
      

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (_gcanvas.style.display != '')
      _gcanvas.style.display = '';
      
    this._divAlert = document.getElementById('prodmon-alert-table');
    this._divSite = document.getElementById('prodmon-site-table');
    this._divWF = document.getElementById('prodmon-workflow-table');
    this._divStats = document.getElementById('prodmon-stats-table');
    this._imageSite = document.getElementById('prodmon-site-image');
    this._imageWF = document.getElementById('prodmon-workflow-image');
//    this._legendSite = document.getElementById('prodmon-site-legend');
//    this._legendWF = document.getElementById('prodmon-workflow-legend');
    this._mapSite = document.getElementById('prodmon-site-map');
    this._mapWF = document.getElementById('prodmon-workflow-map');
    
    this._divSite.innerHTML = "<ol><li>Site</li><li>Site</li><li>Site</li><li>Site</li><li>Site</li></ol>";
    this._divWF.innerHTML = "<ol><li>Workflow</li><li>Workflow</li><li>Workflow</li><li>Workflow</li><li>Workflow</li></ol>";
    this._divAlert.innerHTML = "No alerts defined";
    
    this._imageSite.src = ROOTPATH + "/plotfairy/prodmon/summary/site/plot+legend";
    this._imageWF.src = ROOTPATH + "/plotfairy/prodmon/summary/wf/plot+legend";
//    this._legendSite.src = ROOTPATH + "/plotfairy/prodmon/summary/site/legend";
//    this._legendWF.src = ROOTPATH + "/plotfairy/prodmon/summary/wf/legend";
    
    //var c1 = YAHOO.util.Connect.asyncRequest('GET',ROOTPATH + "/plotfairy/prodmon/summary/site/table",{success:GUI.Plugin.ProdmonSummary.receiveText,argument:'site-table'});
    //var c2 = YAHOO.util.Connect.asyncRequest('GET',ROOTPATH + "/plotfairy/prodmon/summary/wf/table",{success:GUI.Plugin.ProdmonSummary.receiveText,argument:'wf-table'});
    var c3 = YAHOO.util.Connect.asyncRequest('GET',ROOTPATH + "/plotfairy/prodmon/summary/site/map",{success:GUI.Plugin.ProdmonSummary.receiveText,argument:'site-map'});
    var c4 = YAHOO.util.Connect.asyncRequest('GET',ROOTPATH + "/plotfairy/prodmon/summary/wf/map",{success:GUI.Plugin.ProdmonSummary.receiveText,argument:'wf-map'});
    
  }

  this.receiveText = function(obj) {
    //if (obj.argument=='site-table')
    //  _self._divSite.innerHTML=obj.responseText;
    //if (obj.argument=='wf-table')
    //  _self._divWF.innerHTML=obj.responseText;
    if (obj.argument=='site-map')
      _self._mapSite.innerHTML=obj.responseText;
    if (obj.argument=='wf-map')
      _self._mapWF.innerHTML=obj.responseText;

  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.listToTable = function(which,toplist)
  {
    var out = "<ol>";
    for (var i=0;i<toplist.length;i++)
    {
      out += "<li><a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.handleMapClick(\""+which+"\",\""+toplist[i]+"\")'>"+toplist[i]+"</a>";
    }
    out += "</ol>";
    return out;
  }
  
  this.update = function(data)
  {
    var wflist = data['top5wf'];
    var sitelist = data['top5site'];
    _self._divSite.innerHTML=_self.listToTable("site",sitelist);
    _self._divWF.innerHTML=_self.listToTable("wf",wflist);
    
    var stats = "<table>"
      + "<tr><td><b>Total workflows</b></td><td>"+data['workflow_count']+"</td></tr>"
      + "<tr><td><b>Total merged events</b></td><td>"+data['total_merged']+"</td></tr>"
      + "<tr><td><b>Total unmerged events</b></td><td>"+data['total_unmerged']+"</td></tr>"
      + "<tr><td><b>Average time/event</b></td><td>"+data['avg_time_per_event']+"</td></tr>"
      + "<tr><td><b>Minimum time/event</b></td><td>"+data['min_time_per_event']+"</td></tr>"
      + "<tr><td><b>Maximum time/event</b></td><td>"+data['max_time_per_event']+"</td></tr>"
      + "</table>";
    _self._divStats.innerHTML=stats;
    
  }
}();

GUI.Plugin.ProdmonGraphBase = new function()
{
  var _gcanvas = document.getElementById('canvas-area');
  var _gui = null;
  var _self = this;
  this._optionsDiv = null;
  this._optionsVisible = true;
  this._timeDiv = null;
  this._timeVisible = false;
  this._imageDiv=null;
  this._imageVisible=false;
  
  this._optWhat = null;
  this._optTime = null;
  this._optImage = null;
  this._optJob = null;
  this._inputRegex = null;
  this._optGraph = null;
  this._optGroup = null;
  
  this._inputH = null;
  this._inputW = null;
  this._inputDPI = null;
  this._inputTimeStart = null;
  this._inputTimeEnd = null;
  
  this._presetDiv = null;
  this._recentDiv = null;
  
  this._submitRegex = null;
  this._submitTime = null;
  this._submitImage = null;
  
  this._imageSize = '';
  
  var _subClass = null;
  
  this._plotImage = null;
  //this._legendImage = null;
  
  this._plotMap = null;
  
  this._divImageArea = null;
  this._divImageLoader = null;
  
  this.attach = function(gui,subclass,topcontent)
  {
    _gui = gui;
    _subClass = subclass;
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    var content = ""
    
    + "<div class='item' style='float:left;padding:.5em';clear:both>"
    + "<div id='prodmon-image-area' style='display:block'>"
      + "<img id='prodmon-plot-image' usemap='#prodmon-plot-map'>"
      //+ "<img id='prodmon-legend-image'>"
      + "<map name='prodmon-plot-map' id='prodmon-plot-map'></map>"
      + "</div>"
      + "<div id='prodmon-image-loader' style='display:none'>"
      + "<img src='"+ROOTPATH+"/static/progress.gif' width='160' height='160' style:'text-align:center;vertical-align:middle'>"
      + "</div>"
      + "</div>"
      + "<div class='item' style='float:right;padding:.5em;width:100'>"
    + "<div><h3>Presets</h3></div><div id='prodmon-left-preset'></div>"
    + "<div><h3>Recent</h3></div><div id='prodmon-left-recent'></div>"
    + "</div>"
      + "</div>"
      + "<div class='item' style='float:right;clear:right;padding:.5em;width:100'>"
      + "<h3>Options<a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.hideOptions(0)'>+</a></h3>"
      + "<div id='prodmon-options'><table>"
      + "<tr><td>Display</td><td><select id='prodmon-what'></select></td></tr>"
      + "<tr><td>Period</td><td><select id='prodmon-time'></select><a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.hideOptions(1)'>+</a><br>"
      + "<div id='prodmon-time-extra' style='display:none'></div></td></tr>"
    + "<tr><td>Image</td><td><select id='prodmon-image'></select><a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.hideOptions(2)'>+</a><br>"
    + "<div id='prodmon-image-extra' style='display:none'></div></td></tr>"
    + "<tr><td>Job Type</td><td><select id='prodmon-job'></select></td></tr>"
    + "<tr><td>Graph</td><td><select id='prodmon-graph'></select></td></tr>"
    + "<tr><td>Regex</td><td><input id='prodmon-regex'><a id='prodmon-regex-submit' href='#'>Submit</a></td></tr>"
    + "<tr><td>Group</td><td><select id='prodmon-group'></select></td></tr>"
    + "</table></div>"
      + "</div>"
      + "<div class='item' style='float:right;clear:right;padding:.5em;width:100'>"
      + "<div><h3>Download</h3></div>"
      + "<div>Plot: <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"plot\",\"png\")'>PNG</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"plot\",\"pdf\")'>PDF</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"plot\",\"svg\")'>SVG</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"plot\",\"ps\")'>PS</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"plot\",\"json\")'>JSON</a></div>"
      + "<div>Legend: <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"legend\",\"png\")'>PNG</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"legend\",\"pdf\")'>PDF</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"legend\",\"svg\")'>SVG</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"legend\",\"ps\")'>PS</a></div>"
      + "<div>Plot+Legend: <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"plot+legend\",\"png\")'>PNG</a> <a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.download(\"plot+legend\",\"svg\")'>SVG</a></div>"
      + "</div>";
      
      content = topcontent+content;

    if (_gcanvas.innerHTML != content)
      _gcanvas.innerHTML = content;

    if (_gcanvas.style.display != '')
      _gcanvas.style.display = '';
      
    this._optionsDiv = document.getElementById('prodmon-options');
    this._timeDiv = document.getElementById('prodmon-time-extra');
    this._imageDiv = document.getElementById('prodmon-image-extra');
    
    this._timeDiv.style.display='none';
    this._imageDiv.style.display='none';
    
    this._optWhat = document.getElementById('prodmon-what');
    this._optTime = document.getElementById('prodmon-time');
    this._optImage = document.getElementById('prodmon-image');
    this._optJob = document.getElementById('prodmon-job');
    this._inputRegex = document.getElementById('prodmon-regex');
    this._optGraph = document.getElementById('prodmon-graph');
    this._optGroup = document.getElementById('prodmon-group');
    
    this._recentDiv = document.getElementById('prodmon-left-recent');
    this._presetDiv = document.getElementById('prodmon-left-preset');
    
    this._divImageArea = document.getElementById('prodmon-image-area');
    this._divImageLoader = document.getElementById('prodmon-image-loader');
    
    this._timeDiv.innerHTML="Start <input id='prodmon-time-start' value='"+_self.formatTime(-2*86400*1000)+"'><br>End <input id='prodmon-time-end' value='"+_self.formatTime(0)+"'> <a id='prodmon-time-submit' href='#'>Submit</a>";
    this._imageDiv.innerHTML="W<input id='prodmon-image-w' value='800' size=4> H<input id='prodmon-image-h' value='600' size=4> DPI<input id=prodmon-image-dpi value='72' size=4> <a id='prodmon-image-submit' href='#'>Submit</a>";
    
    this._inputH = document.getElementById('prodmon-image-h');
    this._inputW = document.getElementById('prodmon-image-w');
    this._inputDPI = document.getElementById('prodmon-image-dpi');
    this._inputTimeStart = document.getElementById('prodmon-time-start');
    this._inputTimeEnd = document.getElementById('prodmon-time-end');
    
    this._optWhat.innerHTML = "<option value='jobs_any'>Jobs</option><option value='evts_read_any'>Events Read</option><option value='time_any'>Time</option><option value='time_by_span'>Batch Slots</option><option value='CMSSW_fail_codes'>Exit Code</option><option value='jobs_success_rates'>Job Quality</option><option value='event_written_any'>Events Written</option>";
    this._optTime.innerHTML = "<option value='12'>12H</option><option value='24'>24H</option><option value='48' selected='selected'>48H</option><option value='96'>96H</option><option value='168'>168H</option>";
    this._optImage.innerHTML = "<option value='640'>640x480</option><option value='800' selected='true'>800x600</option><option value='1024'>1024x768</option><option value='1280'>1280x1024</option>";
    this._optJob.innerHTML = "<option value='Any'>Any</option><option value='Merge'>Merge</option><option value='Production'>Production</option>";
    this._optGraph.innerHTML = "<option value='bar'>Bar</option><option value='pie'>Pie</option><option value='cumulative'>Cumulative</option>";
    this._optGroup.innerHTML = "<option value='null'></option>";
    
    this._optWhat.onchange = function() {_self.sendInput('what',this.value); return false; };
    this._optTime.onchange = function() {_self.sendTime(this.value); return false; };
    this._optJob.onchange = function() {_self.sendInput('job',this.value); return false; };
    this._optGraph.onchange = function() {_self.sendInput('graph',this.value); return false; };
    this._optImage.onchange = function() {_self.sendSize(this.value); return false; };
    this._optGroup.onchange = function() {_self.sendInput('group',this.value); return false; };
    
  this._submitRegex = document.getElementById('prodmon-regex-submit');
  this._submitTime = document.getElementById('prodmon-time-submit');
  this._submitImage = document.getElementById('prodmon-image-submit');
  
  this._submitRegex.onclick = function() {_self.sendRegex(_self._inputRegex.value); return false; };
  this._submitTime.onclick = function() {_self.sendTime2(_self._inputTimeStart.value,_self._inputTimeEnd.value); return false; };
  this._submitImage.onclick = function() {_self.sendSize3(_self._inputW.value,_self._inputH.value,_self._inputDPI.value); return false; };
  
  this._plotImage = document.getElementById('prodmon-plot-image');
  //this._legendImage = document.getElementById('prodmon-legend-image');
  
  this._plotMap = document.getElementById('prodmon-plot-map');
  
    
  }

  this.download = function(what,format) {
    window.location.href = _self._plotImage.src.replace(/plot\+legend/,what) + ";type=" + format.toLowerCase();
    return false;
  }
  
  this.receiveText = function(obj) {
      if (obj.argument=='plot-map')
        _self._plotMap.innerHTML = obj.responseText;
    
  }

  this.handleMapClick = function(plottype,block)
  {
    if (plottype=='site')
      GUI.makeCall(_url() + "/view?name=site-single;site=" + encodeURIComponent(block));
  if (plottype=='wf')
    GUI.makeCall(_url() + "/view?name=wf-single;wf=" + encodeURIComponent(block));
  
  }
  
  this.handleMapMouse = function(plottype,block,value)
  {
    return
  }

  this.formatTime = function(msoffset)
  {
    var now = new Date();
    now.setTime(now.getTime()+msoffset);
    return now.getUTCFullYear()+"-"+(now.getUTCMonth()+1)+"-"+now.getUTCDate()+" "+now.getUTCHours()+":"+now.getUTCMinutes()+":"+now.getUTCSeconds();
  }

  this.sendRegex = function(value)
  {
    if (value=='') value='null';
    this.sendInput('regex',value);
  }

  this.sendInput = function(what,value)
  {
    _gui.makeCall(_url() + "/graph?" + encodeURIComponent(what) + "=" + encodeURIComponent(value));
  }
  this.sendTime2 = function(start,end)
  {
    if (start != '' && end != '') _gui.makeCall(_url() +"/graph?starttime="+encodeURIComponent(start)+";endtime="+encodeURIComponent(end));
  }
  this.sendTime = function(span)
  {
    var start = this.formatTime(-3600*1000*parseInt(span));
    var end = this.formatTime(0);
    this.sendTime2(start,end);
  }
  this.sendSize = function(preset)
  {
    switch(preset) {
      case '640':
      this.sendSize3(640,480,72);
        break;
      case '800':
      this.sendSize3(800,600,72);
        break;
      case '1024':
        this.sendSize3(1024,768,72);
        break;
      case '1280':
        this.sendSize3(1280,1024,72);
        break;
    }
  }
  this.sendSize3 = function(w,h,dpi)
  {
    this._imageSize = 'width='+encodeURIComponent(w)+';height='+encodeURIComponent(h)+';dpi='+encodeURIComponent(dpi);
    this.replot();
  }
  this.sendRecent = function(index) 
  {
    _gui.makeCall(_url() + "/recent?n=" + encodeURIComponent(index));
  }
  
  this.sendPreset = function(index)
  {
    _gui.makeCall(_url() + "/preset?n=" + encodeURIComponent(index));
  }
  
  this.setSelection = function(listobj,which)
  {
  for (var i=0;i<listobj.length;i++)
  {
    if (listobj.options[i].value==which)
    {
      listobj.selectedIndex = i;
    }
  } 
  }
  
  this.hideOptions = function(group)
  {
      if (group==0) {
        if (this._optionsVisible) {
          this._optionsDiv.style.display='none';
          this._optionsVisible=false;
      } else {
          this._optionsDiv.style.display='block';
          this._optionsVisible=true;
        }
      }
      if (group==1) {
        if (this._timeVisible) {
          this._timeDiv.style.display='none';
          this._timeVisible=false;
      } else {
          this._timeDiv.style.display='block';
          this._timeVisible=true;
        }
      }
      if (group==2) {
        if (this._imageVisible) {
          this._imageDiv.style.display='none';
          this._imageVisible=false;
      } else {
          this._imageDiv.style.display='block';
          this._imageVisible=true;
        }
      }
  }

  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }

  this.update = function(data)
  {
    this.setSelection(this._optWhat,data['what']);
    this.setSelection(this._optJob,data['job']);
    this.setSelection(this._optGraph,data['graph']);
    this.setSelection(this._optGroup,data['group']);
  var preset = data['preset'];
  if (preset != null) {
    var pcontent = "";
    for (var i=0;i<preset.length;i++) {
      pcontent += "<div><a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.sendPreset("+i+")'>"+preset[i]+"</a></div>";
    }
    this._presetDiv.innerHTML=pcontent;
  }

    var recent = data['recent'];
    if (recent != null) {
      var rcontent="";
      for (var i=0;i<recent.length;i++) {
        rcontent += "<div><a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.sendRecent("+i+")'>"+recent[i]+"</a></div>";
      } 
      this._recentDiv.innerHTML=rcontent;
    }
    
    var regex = data['regex'];
    if (regex != null)
      if (regex=='null')
        this._inputRegex.value='';
      else
        this._inputRegex.value = data['regex'];
  var starttime = data['starttime'];
  var endtime = data['endtime'];
  if (starttime!='' && starttime!=null)
      this._inputTimeStart.value = data['starttime'];
  if (endtime!='' && endtime!=null)
      this._inputTimeEnd.value = data['endtime'];
    if (starttime!='' && starttime!=null && endtime!='' && endtime!=null) {
      var fixstart = starttime.replace(/-/g,'/');
      var fixend = endtime.replace(/-/g,'/');
      var startdate = Date.parse(fixstart);
      var enddate = Date.parse(fixend);
      var hours = (enddate-startdate)/3600000;
      this.setSelection(this._optTime,hours.toString());
    }
    
    var replot = data['forceplot'];
    if (replot) {
      this.replot();  
    }
  }
  
  this.loadPlot = function(what,sort,plottype,jobtype,opts) {
    var basesrc = ROOTPATH + "/plotfairy/prodmon/"
      + encodeURIComponent(what)+"/"
      + encodeURIComponent(sort)+"/"
      + encodeURIComponent(plottype)+"/"
      + encodeURIComponent(jobtype);
    var plotsrc = basesrc+"/plot+legend?"+opts;
    //var legendsrc = basesrc+"/legend?"+opts;
    var mapsrc = basesrc+"/map?"+opts;
    
    var loadersize = _self._optImage.value;
  _self._divImageArea.style.display='none';

    _self._divImageLoader.style.width=loadersize;
    _self._divImageLoader.style.height=loadersize;
    _self._divImageLoader.style.display='block';

  _self._plotImage.onload = function() {_self._divImageLoader.style.display='none'; _self._divImageArea.style.display='block'; return false; };   
    _self._plotImage.src = plotsrc
    //_self._legendImage.src = legendsrc
    //_self._plotImage.usemap = mapsrc //this doesn't seem to work
    
    var c1 = YAHOO.util.Connect.asyncRequest('GET',mapsrc,{success:GUI.Plugin.ProdmonGraphBase.receiveText,argument:'plot-map'});
    
  }
  

  this.replot=function() {
    _subClass.replot();
  }
  this.sendTyping=function() {
    _singleSelected=null;
  var text = _subClass._inputSelect.value;
    if (text!='') _gui.makeCall(_url() + "/typing?text=" + encodeURIComponent(text));
  }
  
  return this;
}();

GUI.Plugin.ProdmonGraphSingleBase = new function()
{
  var _singleSubClass = null;
  
  this._labelSelect = null;
  this._inputSelect = null;
  this._resultSelect = null;
  this._singleSelected = null;
  
  this.base = GUI.Plugin.ProdmonGraphBase;
  this.attach = function(gui,subclass) { 
    _singleSubClass = subclass; 
     

    var scontent = ""
      + "<div class='item' style='float:left;clear:both;padding:.5em'>"
      + "<h3 id='prodmon-single-label'></h3>"
      + "<input type='text' value='' id='prodmon-single-input' size=100 autocomplete='off' onkeyup='return GUI.Plugin.ProdmonGraphBase.sendTyping()'>"
      + "<div id='prodmon-single-result'></div>"
      + "</div>";
    this.base.attach(gui,this,scontent);
    
    this._labelSelect = document.getElementById('prodmon-single-label');
    this._inputSelect = document.getElementById('prodmon-single-input');
    this._resultSelect = document.getElementById('prodmon-single-result');
  }
  this.detach = function() {
     _singleSubClass = null;
     _singleSelected = null; 
     this.base.detach(); 
  }
  this.update = function(data) { 
  var ac = data['autocomplete'];
  if (ac) {
    if (ac.length==1) {
      var comp = ac[0];
      this._inputSelect.value = comp;
      this._singleSelected = comp;
      this._resultSelect.innerHTML = "";
      this.replot();
    } else {
      _singleSelected = null;
      var accontent = "<ul>";
      for (var i=0;i<ac.length;i++) {
        accontent+="<li><a href='#' onclick='return GUI.Plugin.ProdmonGraphSingleBase.selectComp(this.innerHTML)'>"+ac[i]+"</a></li>";  
        if (i>10) {
          accontent+="<li>...</li>";
          break;
        }
      }
      accontent += "</ul>";
      this._resultSelect.innerHTML=accontent;
    }
  }
    this.base.update(data); 
  }
  this.replot = function() {
    if (this._singleSelected)
      _singleSubClass.replot();
  }
  this.selectComp = function(comp) {
    this._inputSelect.value = comp;
    this._singleSelected = comp;
    this._resultSelect.innerHTML="";
    this.replot();
  }
  
  
  return this;
}();

GUI.Plugin.ProdmonSiteMultiple = new function()
{
  this.base = GUI.Plugin.ProdmonGraphBase;
  this.attach = function(gui) { 
    this.base.attach(gui,this,""); 
    this.base._optGroup.innerHTML = "<option value='null'>None</option><option value='tier'>Tier</option><option value='country'>Country</option><option value='region'>Region</option><option value='tiercountry'>Tier, Country</option><option value='tierregion'>Tier, Region</option>";
  }
  this.detach = function() { this.base.detach(); }
  this.update = function(data) { this.base.update(data); }
  this.replot = function()
  {
    var opts = this.base._imageSize+";starttime="+encodeURIComponent(this.base._inputTimeStart.value)+";endtime="+encodeURIComponent(this.base._inputTimeEnd.value)+";sitex="+encodeURIComponent(this.base._inputRegex.value)+";group="+encodeURIComponent(this.base._optGroup.value);
  this.base.loadPlot(this.base._optWhat.value,"site",this.base._optGraph.value,this.base._optJob.value,opts);
  }
  return this;
}();

GUI.Plugin.ProdmonWFMultiple = new function()
{
  this.base = GUI.Plugin.ProdmonGraphBase;
  this.attach = function(gui) { 
    this.base.attach(gui,this,"");
    this.base._optGroup.innerHTML = "<option value='null'>None</option><option value='1'>Primary</option><option value='2'>Secondary</option><option value='3'>Tertiary</option>";
  }
  this.detach = function() { this.base.detach(); }
  this.update = function(data) { this.base.update(data); }
  this.replot = function()
  {
    var opts = this.base._imageSize+";starttime="+encodeURIComponent(this.base._inputTimeStart.value)+";endtime="+encodeURIComponent(this.base._inputTimeEnd.value)+";wfx="+encodeURIComponent(this.base._inputRegex.value)+";group="+encodeURIComponent(this.base._optGroup.value);
  this.base.loadPlot(this.base._optWhat.value,"wf",this.base._optGraph.value,this.base._optJob.value,opts);
  }
  return this;
}();

GUI.Plugin.ProdmonSiteSingle = new function()
{
  this.base = GUI.Plugin.ProdmonGraphSingleBase;
  this.attach = function(gui) { 
    this.base.attach(gui,this); 
    this.base.base._optGroup.innerHTML = "<option value='null'>None</option><option value='1'>Primary</option><option value='2'>Secondary</option><option value='3'>Tertiary</option>";
    this.base._labelSelect.innerHTML = "Site:";
    this.base._singleSelected = null;
  }
  this.detach = function() { this.base.detach(); }
  this.update = function(data) { this.base.update(data); }
  this.replot = function()
  {
    var opts = this.base.base._imageSize+";starttime="+encodeURIComponent(this.base.base._inputTimeStart.value)+";endtime="+encodeURIComponent(this.base.base._inputTimeEnd.value)+";site="+encodeURIComponent(this.base._singleSelected)+";group="+encodeURIComponent(this.base.base._optGroup.value);
  this.base.base.loadPlot(this.base.base._optWhat.value,"wf",this.base.base._optGraph.value,this.base.base._optJob.value,opts);
  }
  return this;
}();

GUI.Plugin.ProdmonWFSingle = new function()
{
  this.base = GUI.Plugin.ProdmonGraphSingleBase;
  this.attach = function(gui) { 
    this.base.attach(gui,this);
    this.base.base._optGroup.innerHTML = "<option value='null'>None</option><option value='tier'>Tier</option><option value='country'>Country</option><option value='region'>Region</option><option value='tiercountry'>Tier, Country</option><option value='tierregion'>Tier, Region</option>"; 
    this.base._labelSelect.innerHTML = "Workflow:";
    this.base._singleSelected = null;
  }
  this.detach = function() { this.base.detach(); }
  this.update = function(data) { this.base.update(data); }
  this.replot = function()
  {
    var opts = this.base.base._imageSize+";starttime="+encodeURIComponent(this.base.base._inputTimeStart.value)+";endtime="+encodeURIComponent(this.base.base._inputTimeEnd.value)+";wf="+encodeURIComponent(this.base._singleSelected)+";group="+encodeURIComponent(this.base.base._optGroup.value);
  this.base.base.loadPlot(this.base.base._optWhat.value,"site",this.base.base._optGraph.value,this.base.base._optJob.value,opts);
  }
  return this;
}();
